#include <tchar.h>
#include <SDKDDKVer.h>
#include <stdint.h>
#include <windows.h>
#include <synchapi.h>
#include <stdio.h>

char code01[] = "Y00000001111111101000000001111111Z"; //timer duration 1 
char code02[] = "Y00000001111111100100000010111111Z"; //timer duration 2
char code03[] = "Y00000001111111101100000000111111Z"; //random color cycles
char code04[] = "Y00000001111111100010000011011111Z"; //full red
char code05[] = "Y00000001111111101010000001011111Z"; //full green
char code06[] = "Y00000001111111100110000010011111Z"; //full blue
char code07[] = "Y00000001111111101110000000011111Z"; //white-pink
char code08[] = "Y00000001111111100001000011101111Z"; //white-lime
char code09[] = "Y00000001111111101001000001101111Z"; //lightblue
char code10[] = "Y00000001111111100101000010101111Z"; //white-yellow
char code11[] = "Y00000001111111100011000011001111Z"; //white-blue
char code12[] = "Y00000001111111101011000001001111Z"; //mid blue
char code13[] = "Y00000001111111100111000010001111Z"; //mid violet
char code14[] = "Y00000001111111100100100010110111Z"; //turn on
char code15[] = "Y00000001111111100101100010100111Z"; //turn off
char code16[] = "Y00000001111111101101100000100111Z"; //turquoise
char code17[] = "Y00000001111111100111100010000111Z"; //toggle full white brightness
char code18[] = "Y00000001111111101111100000000111Z"; //pink

HANDLE open_serial_port(const char * device, uint32_t baud_rate)
{
	HANDLE port = CreateFileA(device, GENERIC_READ | GENERIC_WRITE, 0, NULL,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (port == INVALID_HANDLE_VALUE)
	{
		printf("%s \n", device);
		return INVALID_HANDLE_VALUE;
	}

	// Flush away any bytes previously read or written.
	BOOL success = FlushFileBuffers(port);
	if (!success)
	{
		printf("Failed to flush serial port\n");
		CloseHandle(port);
		return INVALID_HANDLE_VALUE;
	}

	// Configure read and write operations to time out after 100 ms.
	COMMTIMEOUTS timeouts = { 0 };
	timeouts.ReadIntervalTimeout = 0;
	timeouts.ReadTotalTimeoutConstant = 100;
	timeouts.ReadTotalTimeoutMultiplier = 0;
	timeouts.WriteTotalTimeoutConstant = 100;
	timeouts.WriteTotalTimeoutMultiplier = 0;

	success = SetCommTimeouts(port, &timeouts);
	if (!success)
	{
		printf("Failed to set serial timeouts\n");
		CloseHandle(port);
		return INVALID_HANDLE_VALUE;
	}

	DCB state;
	state.DCBlength = sizeof(DCB);
	success = GetCommState(port, &state);
	if (!success)
	{
		printf("Failed to get serial settings\n");
		CloseHandle(port);
		return INVALID_HANDLE_VALUE;
	}

	state.BaudRate = baud_rate;

	success = SetCommState(port, &state);
	if (!success)
	{
		printf("Failed to set serial settings\n");
		CloseHandle(port);
		return INVALID_HANDLE_VALUE;
	}

	return port;
}

int random_number(int lower, int upper)
{
	int num = (rand() % (upper - lower + 1)) + lower;
	printf("random # - %d in range %d-%d\n", num, lower, upper);
	return (num);
}

void write_ir_packet(char* ir_code, HANDLE filehandle)
{
	int loopcounter;
	DWORD number_bytes_written;
	for (loopcounter = 1; loopcounter <= strlen(ir_code); loopcounter++)
	{
		while (WriteFile(filehandle, &ir_code[loopcounter - 1], 1, &number_bytes_written, NULL) == FALSE) {}
	}
	printf("sending - %s\n", ir_code);
}

void color_blink(char* ir_code_in1, char* ir_code_in2, int blink_delay, HANDLE filehandle, int times)
{
	int loopcounter;
	for (loopcounter = 0; loopcounter <= times; loopcounter++)
	{
		write_ir_packet(ir_code_in1, filehandle);
		Sleep(blink_delay);
		write_ir_packet(ir_code_in2, filehandle);
		Sleep(blink_delay);
	}
}

void color_cycle(int blink_delay, HANDLE filehandle, int times)
{
	int loopcounter;
	for (loopcounter = 0; loopcounter <= times; loopcounter++)
	{
		write_ir_packet(code04, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code13, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code10, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code05, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code18, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code08, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code12, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code16, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code06, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code07, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code11, filehandle);
		Sleep(blink_delay);
		write_ir_packet(code09, filehandle);
		Sleep(blink_delay);
	}
}

void random_primaries(int blink_delay, HANDLE filehandle, int times)
{
	int random_selector;
	int loopcounter;
	for (loopcounter = 0; loopcounter <= times; loopcounter++)
	{
		random_selector = random_number(1, 29);
		if (random_selector < 10) { write_ir_packet(code04, filehandle); }
		if ((random_selector < 20) && (random_selector > 9)) { write_ir_packet(code05, filehandle); }
		if ((random_selector < 30) && (random_selector > 19)) { write_ir_packet(code06, filehandle); }
		Sleep(blink_delay);
	}
}

void random_tints(int blink_delay, HANDLE filehandle, int times)
{
	int random_selector;
	int loopcounter;
	for (loopcounter = 0; loopcounter <= times; loopcounter++)
	{
		random_selector = random_number(1, 39);
		if (random_selector < 10) { write_ir_packet(code07, filehandle); }
		if ((random_selector < 20) && (random_selector > 9)) { write_ir_packet(code08, filehandle); }
		if ((random_selector < 30) && (random_selector > 19)) { write_ir_packet(code10, filehandle); }
		if ((random_selector < 40) && (random_selector > 29)) { write_ir_packet(code11, filehandle); }
		Sleep(blink_delay);
	}
}

void color_morph(char* ir_code_in1, char* ir_code_in2, HANDLE filehandle, int times)
{
	float amount_1;
	float amount_2;
	float slicesize = 180 / times;
	int loopcounter;

	for (loopcounter = 10; loopcounter <= (times - 10); loopcounter++)
	{
		amount_2 = slicesize * loopcounter;
		amount_1 = 180 - amount_2;
		if (amount_1 > 30) write_ir_packet(ir_code_in1, filehandle);
		Sleep(amount_1);
		if (amount_2 > 30) write_ir_packet(ir_code_in2, filehandle);
		Sleep(amount_2);
	}
}

void color_hold(char* ir_code_in1, HANDLE filehandle, long delay)
{
	write_ir_packet(ir_code_in1, filehandle);
	Sleep(delay);
}

int main()
{
	// My arduino is on COM3, you may have to alter the next line
	const char * device = "\\\\.\\COM3";

	HANDLE hComm = 0;

	hComm = open_serial_port(device, 115200);

	Sleep(2000);
	//turn light on
	write_ir_packet(code14, hComm);
	Sleep(500);

	/* put your light routines here
	times are all in milliseconds max is 1000ms
	except for color_hold which allows up to 1000000ms */

	color_cycle(400, hComm, 2);
	random_primaries(400, hComm, 20);
	random_tints(400, hComm, 20);
	color_blink(code04, code06, 300, hComm, 30);
	color_morph(code09, code06, hComm, 50);
	color_morph(code06, code18, hComm, 50);
	color_morph(code18, code04, hComm, 50);
	color_hold(code04, hComm, 2500);

	//turn light off
	Sleep(500);
	write_ir_packet(code15, hComm);
	CloseHandle(hComm);
	return (1);
}

